/*
    nast

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#include "include/nast.h"

/* handle a tcp packet */
void handle_TCP (u_short d, u_short x, FILE *output, FILE *ldd)
{
   struct libnet_ipv4_hdr *ip;
   struct libnet_tcp_hdr *tcp;
   struct servent *service;
   u_char flags;
   u_short size_ip, size_tcp, size_buf;

   size_ip = LIBNET_IPV4_H;
   size_buf = 0;

   ip = (struct libnet_ipv4_hdr *) (packet+offset);
   tcp = (struct libnet_tcp_hdr *) (packet+size_ip+offset);

   size_tcp = (tcp->th_off) * 4;

   fprintf(output, "\n---[ TCP ]-----------------------------------------------------------\n");
   service = getservbyport(htons(ntohs(tcp->th_sport)), "tcp");
   fprintf(output, "%s:%d(%s)",inet_ntoa(ip->ip_src),ntohs(tcp->th_sport),(service) ? service->s_name : "unknown");
   service = getservbyport(htons(ntohs(tcp->th_dport)), "tcp");
   fprintf(output, " -> ");
   fprintf(output, "%s:%d(%s)\n",inet_ntoa(ip->ip_dst),ntohs(tcp->th_dport),(service) ? service->s_name : "unknown");
   fprintf(output, "TTL: %d \t", ip->ip_ttl);
   fprintf(output, "Window: %d\t", ntohs(tcp->th_win));
   fprintf(output, "Version: %d\t", ip->ip_v);
   fprintf(output, "Lenght: %d\n", ntohs(ip->ip_len));
   fprintf(output, "FLAGS: ");

   /* modifed by embyte */
   flags = tcp->th_flags;

   if (flags & TH_FIN) /* se mascherando con il fin ottengo 1 vuol dire che c (l'and  1 se tutti e due sono 1) */
     fputc('F', output);
   else
     fputc('-', output);
   if (flags & TH_SYN)
     fputc('S', output);
   else
     fputc('-', output);
   if (flags & TH_RST)
     fputc('R', output);
   else
     fputc('-', output);
   if (flags & TH_PUSH)
     fputc('P', output);
   else
     fputc('-', output);
   if (flags & TH_ACK)
     fputc('A', output);
   else
     fputc('-', output);
   if (flags & TH_URG)
     fputc('U', output);
   else
     fputc('-', output);
   if (flags & 0x80) /* ECN Cwnd Reduced */
     fputc('W', output);
   else
     fputc('-', output);
   if (flags & 0x40) /* ECN Echo */
     fputc('E', output);

   fprintf(output, "\tSEQ: %u - ACK: %u\n", ntohl(tcp->th_seq),ntohl(tcp->th_ack));

   size_buf = ntohs(ip->ip_len) - size_ip - size_tcp;

   /* there is a payload */
   if (size_buf)
     {
	buf = (char *) (packet + offset + size_ip + size_tcp);

	if (d)
	  {
	     fprintf(output, "\n---[ TCP Data ]------------------------------------------------------\n");
	     data_sniffo (buf, size_buf, output);
	     fprintf (output, "\n");
	  }

	if (x)
	  {
	     fprintf(output, "\n---[ TCP Hex-Ascii Data ]--------------------------------------------");
	     print_ascii_hex (buf, size_buf, output);
	     fprintf(output, "\n");
	  }

        /* log data (payload only) */
	if (ldd)
	  {

	     service = getservbyport(htons(ntohs(tcp->th_sport)), "tcp");
	     fprintf(ldd, "%s:%d(%s) -> ",inet_ntoa(ip->ip_src),ntohs(tcp->th_sport),(service) ? service->s_name : "unknown");
	     service = getservbyport(htons(ntohs(tcp->th_dport)), "tcp");
	     fprintf(ldd, "%s:%d(%s) TCP\n",inet_ntoa(ip->ip_dst),ntohs(tcp->th_dport),(service) ? service->s_name : "unknown");

	     data_sniffo (buf, size_buf, ldd);
	     fprintf(ldd, "\n");

	  }
     }
}
